Subject: RE: WG Last Call: draft-ietf-ldapbis-protocol-17.txt [corrected]

From: "Jim Sermersheim" <[email-masked]>
Date: Mon, 06 Oct 2003 23:11:42 -0600

Sounds good to me. I wasn't aware that ASN.1 allows that.
 
Also, is it any different from:
 
AttributeList ::= SEQUENCE OF Attribute 
 
Attribute ::= SEQUENCE { 
type AttributeDescription, 
vals SET OF value AttributeValue }
 
Jim

>>> "Steven Legg" <[email-masked]> 10/6/03 6:07:13 PM >>>

Folks,

I recently published an Internet draft on an XML rendition of the LDAP
protocol (called XLDAP) that is realized by applying a set of XML
encoding rules to the ASN.1 types in the ASN.1 specification for LDAP
(specifically the ASN.1 in the protocols draft being last-called).

The XML produced is neat and tidy except with respect to the instances
of the member type of a SEQUENCE OF or SET OF ASN.1 type.

Consider this example drawn from the protocols draft:

AttributeList ::= SEQUENCE OF SEQUENCE { 
type AttributeDescription, 
vals SET OF AttributeValue } 

Using my Directory XML Encoding Rules (DXER) to encode an attribute
list,
each attribute in the list is encoded as an element with the safe, but
bland name of <item>. Using the ITU-T's XML Encoding Rules (XER), each
attribute in the list is encoded as an element with the unappealing
name
of <SEQUENCE>.

However the situation can be improved since the version of ASN.1 that
the protocols draft is referencing allows an ASN.1 identifier after a
SEQUENCE OF or SET OF and before the definition of the member type.

For example:

AttributeList ::= SEQUENCE OF attribute SEQUENCE { 
type AttributeDescription, 
vals SET OF value AttributeValue } 

With this change both DXER and XER would encode each attribute in the
list
as an element with the more meaningful name of <attribute>. This
change
makes no difference to the BER encoding, so it is neutral to LDAP and
does
not represent a new feature.

I would like to see each of the SEQUENCE OF and SET OF definitions in
the
LDAP ASN.1 module given a meaningful mnemonic identifier for the member
type
so as to facilitate better XML representations of LDAP operations
(whether
for XLDAP or any other purpose). If the working group allows it I'll
work
with Jim to make the additions.

Regards,
Steven

---

From: Steven Legg <[email-masked]>
Date: Tue, 07 Oct 2003 17:17:04 +1100

Hi Jim,

> Sounds good to me. I wasn't aware that ASN.1 allows that.

It was added after the 1997 edition of ASN.1.

> AttributeList ::= SEQUENCE OF Attribute

DXER would still encode each instance of the Attribute ASN.1 type
as an element with the name <item>. In this case XER would instead
encode each instance as an element with the name <Attribute>. Thus
XER is more sensitive to reorganization of the ASN.1 specification
than is DXER.

If the notation were either

    AttributeList ::= SEQUENCE OF attribute Attribute

or

then DXER and XER would both use the name <attribute> (in both cases).

Regards,
Steven

> Using my Directory XML Encoding Rules (DXER) to encode an attribute list,
> attribute in the list is encoded as an element with the unappealing name
> of <SEQUENCE>.
> 
> With this change both DXER and XER would encode each attribute in the list
> as an element with the more meaningful name of <attribute>. This change
> makes no difference to the BER encoding, so it is neutral to LDAP and does
> I would like to see each of the SEQUENCE OF and SET OF definitions in the
> LDAP ASN.1 module given a meaningful mnemonic identifier for the member type
> so as to facilitate better XML representations of LDAP operations (whether
> for XLDAP or any other purpose). If the working group allows it I'll work